"A module for fractions."

def MCD(a, b):
    if b == 0:
        return a
    return MCD(b, a%b)
def mcm(a,b):
    return (a*b)/MCD(a,b)

class Fraction(object):
    def __init__(self, numerator=1, denominator=1):
        self.num = int(numerator)
        self.den = int(denominator)
    def __str__(self):
        return "%d/%d" % (self.num, self.den)
    def simplify(self):
        div = MCD(self.num, self.den)
        res = Fraction(self.num/div, self.den/div)
        return res
    def common_den(self, other):
        return mcm(self.den, other.den)
    def calculate(self):
        return self.num / self.den
    def __lt__(self, other):
        x1 = self.num * other.den
        x2 = self.den * other.num
        return x1 < x2
    def __eq__(self, other):
        ss = self.simplify()
        os = other.simplify()
        return ss.num == os.num and ss.den == os.den
    def __gt__(self,other):
        return not (self<other or self==other)
    def __ne__(self,other):
        return not self == other
    def __ge__(self, other):
        return self>other or self==other
    def __le__(self,other):
        return self<other or self==other