"""
Queue module.
You can ue it for making queues.
"""

class Queue(object):
    """
A class implementing a FIFO (queue), with list objects.
See the code and the methods' documentation for details.
    """
    def __init__(self, elements=None):
        """
This initializes a queue with an empty list, or with a sequence.
        """
        self.elements = [] if elements == None else list(elements)
    def __str__(self):
        """
This method returns a string representation of the queue.
        """
        return "Queue("+str(self.elements)+")"
    def __lt__(self, x):
        """
This method checks if "self" is less than "x".
The following methods are similar to this one.
These checks if 'self' is greater than "x", and similar comparisons.
        """
        assert isinstance(x, Queue)
        return len(self.elements) < len(x.elements)
    def __gt__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Queue)
        return len(self.elements) > len(x.elements)
    def __eq__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Queue)
        return self.elements == x.elements
    def __ne__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Queue)
        return not self == x
    def __ge__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Queue)
        return self > x or self == x
    def __le__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Queue)
        return self < x or self == x
    def append(self, x):
        """
This appends an element at the end of the queue.
        """
        self.elements.append(x)
    def pop(self):
        """
This gets the first element from the queue, and then remove it.
        """
        if self.empty(): raise ValueError("queue is empty")
        return self.elements.pop(0)
    def empty(self):
        """
This checks if the queue is empty.
        """
        return not bool(len(self.elements))