"""
Stack module.
You can ue it for making stacks.
"""

class Stack(object):
    """
A class implementing a LIFO (stack), with list objects.
See the code and the methods' documentation for details.
    """
    def __init__(self, elements=None):
        """
This initializes a stack with an empty list, or with a sequence.
        """
        self.elements = [] if elements == None else list(elements)
    def __str__(self):
        """
This method returns a string representation of the stack.
        """
        return "Stack("+str(self.elements)+")"
    def __lt__(self, x):
        """
This method checks if "self" is less than "x".
The following methods are similar to this one.
These checks if 'self' is greater than "x", and similar comparisons.
        """
        assert isinstance(x, Stack)
        return len(self.elements) < len(x.elements)
    def __gt__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Stack)
        return len(self.elements) > len(x.elements)
    def __eq__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Stack)
        return self.elements == x.elements
    def __ne__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Stack)
        return not self == x
    def __ge__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Stack)
        return self > x or self == x
    def __le__(self, x):
        """
See __lt__ documentation for details.
        """
        assert isinstance(x, Stack)
        return self < x or self == x
    def append(self, x):
        """
This appends an element at the end of the stack.
        """
        self.elements.append(x)
    def pop(self):
        """
This gets the last element from the stack, and then remove it.
        """
        if self.empty(): raise ValueError("stack is empty")
        return self.elements.pop()
    def empty(self):
        """
This checks if the stack is empty.
        """
        return not bool(len(self.elements))