"""
Tree module.
You can ue it for making trees.
"""

def EmptyTree():
    """
Returns an empty tree.
    """
    return None

def Leaf(c):
    """
Returns a tree leaf.
    """
    return Tree(c)

def isEmpty(t):
    "Is t an empty tree?"
    return t == None

class Tree(list):
    """
A special kind of list that contains a tree.
    """
    def __init__(self, content, left=EmptyTree(), right=EmptyTree()):
        "Initializes a tree"
        self.append(content)
        self.append(left)
        self.append(right)
    def isLeaf(self):
        "Is this tree node a leaf?"
        return isEmpty(self[1]) and isEmpty(self[2])
    def left(self):
        "Returns the left branch of the tree."
        return self[1]
    def right(self):
        "Returns the right branch of the tree."
        return self[2]
    def root(self):
        "Returns the root content of this node."
        return self[0]
    def setLeft(self, node):
        "Changes the left branch of the tree."
        self[1] = node
    def setRight(self, node):
        "Changes the right branch of the tree."
        self[2] = node

def search(tree, x):
    "Returns True if tree contains x."
    if isEmpty(tree): return False
    if x == tree.root():
        return True
    if x < tree.root():
        return search(tree.left(), x)
    return search(tree.right(), x)

def _insert(tree, x):
    "Don't use this."
    if isEmpty(tree): return MathTree(x)
    if x < tree.root():
        return MathTree(tree[0], _insert(tree[1], x), tree[2])
    elif x > tree.root():
        return MathTree(tree[0], tree[1], _insert(tree[2], x))
    else:
        return tree
class MathTree(Tree):
    "A mathematics tree, with insert and remove operations. setLeft and setRight are disabled."
    def setLeft(*args):
        raise RuntimeError("You cannot set MathTree elements. Use insert method instead.")
    setRight = setLeft
    def insert(self, x):
        "Inserts an element into the tree. Note: it returns the new tree."
        self = _insert(self, x)
        return self
    def maximum(self):
        if isEmpty(self.right()):
            return self.root()
        return self.right().maximum()
    def minimum(self):
        if isEmpty(self.left()):
            return self.root()
        return self.left().minimum()

